/*!
 * SAP UI development toolkit for HTML5 (SAPUI5)

(c) Copyright 2009-2016 SAP SE. All rights reserved
 */
sap.ui.define(['sap/ui/core/Element','sap/viz/library','./AnalysisObject'],function(E,l,A){"use strict";var F=E.extend("sap.viz.ui5.controls.common.feeds.FeedItem",{metadata:{library:"sap.viz",properties:{uid:{type:"string",group:"Misc",defaultValue:null},type:{type:"string",group:"Misc",defaultValue:null},values:{type:"any[]",group:"Misc",defaultValue:null}}}});F.prototype._toInnerFmt=function(g){var u=this.getProperty('uid');var t=this.getProperty('type');var v=this.getProperty('values');if(u&&t){this._analysisObjects=[];if(v){var i=u==="timeAxis";v.forEach(function(a,b,v){if(typeof a==='string'){this._analysisObjects[b]=new A({'uid':a,'name':a,'type':a==='MND'?'MND':t});}else if(a instanceof A){this._analysisObjects[b]=a;}else{return;}if(i){this._analysisObjects[b].setDataType("date");}}.bind(this));}return g(u,t,this._analysisObjects);}};F.toVizControlsFmt=function(f){return Array.prototype.map.call(f,function(a){return a._toInnerFmt(function(i,t,v){return new sap.viz.controls.common.feeds.FeedItem(i,t,sap.viz.ui5.controls.common.feeds.AnalysisObject.toVizControlsFmt(v));});});};F.fromVizControlsFmt=function(f){return Array.prototype.map.call(f,function(i){return new F({'uid':i.id(),'type':i.type(),'values':sap.viz.ui5.controls.common.feeds.AnalysisObject.fromVizControlsFmt(i.values())});});};F.toLightWeightFmt=function(f){return Array.prototype.map.call(f,function(a){return a._toInnerFmt(function(i,t,v){return{'id':i,'type':t,'values':sap.viz.ui5.controls.common.feeds.AnalysisObject.toLightWeightFmt(v)}});});};F.fromLightWeightFmt=function(f){return Array.prototype.map.call(f,function(i){return new F({'uid':i.id,'type':i.type,'values':sap.viz.ui5.controls.common.feeds.AnalysisObject.fromLightWeightFmt(i.values)});});};return F;});
